// Generated by CoffeeScript 1.9.1
(function() {
  var PrologDb, async, pengines, prologdb, qs, simpleAuth,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  qs = require('qs');

  pengines = require('pengines');

  simpleAuth = require('./simpleAuth');

  async = require('async');

  PrologDb = (function() {
    var openQueries;

    openQueries = {};

    function PrologDb(options) {
      this.openQuery = bind(this.openQuery, this);
      this.queryN = bind(this.queryN, this);
      this.query = bind(this.query, this);
      this.authenticate = bind(this.authenticate, this);
      this.authOptions = options.authOptions, this.applicationName = options.applicationName, this.serverUrl = options.serverUrl, this.maxQueryLength = options.maxQueryLength, this.sourceText = options.sourceText;
      if (this.maxQueryLength == null) {
        this.maxQueryLength = 1000;
      }
      if (this.applicationName == null) {
        this.applicationName = "swish";
      }
      if (this.sourceText == null) {
        this.sourceText = "";
      }
    }

    PrologDb.prototype.authenticate = function(callback) {
      if (this.authOptions != null) {
        return simpleAuth(this.authOptions, (function(_this) {
          return function() {
            var cookieJar, error;
            error = arguments[0], cookieJar = arguments[arguments.length - 1];
            _this.cookieJar = cookieJar;
            return callback(error, _this);
          };
        })(this));
      } else {
        this.cookieJar = request.jar();
        return callback(null, this);
      }
    };

    PrologDb.prototype.addPresetSourceText = function(sourceText, callback) {
      return this.sourceText = this.sourceText != null ? this.sourceText + "\n" + fileContent : sourceText;
    };


    /*@connect : (options,callback) ->
        #newPrologDb =
        
        new PrologDb(options).open( (error,newPrologDb) =>
            callback(error,newPrologDb)
        )
     */

    PrologDb.prototype.query = function(queryString, callback) {
      return queryN(queryString, this.maxQueryLength, callback);
    };

    PrologDb.prototype.queryN = function(queryString, chunk, callback) {
      var peng, pengineOptions, queryResult;
      pengineOptions = {
        server: this.serverUrl,
        application: this.applicationName,
        format: "json",
        destroy: true,
        sourceText: this.sourceText,
        ask: queryString,
        chunk: chunk,
        cookieJar: this.cookieJar
      };
      queryResult = null;
      return peng = pengines(pengineOptions).on('error', function(obj) {
        return callback(new Error("Error in operation: " + obj.data));
      }).on('failure', function(error) {
        return callback(new Error("Pengine object failed: " + obj.data));
      }).on('destroy', function() {
        return callback(null, queryResult);
      }).on('success', function(result) {
        queryResult = result;
        return peng.destroy();
      });
    };

    PrologDb.prototype.queryMore = function(queryId, callback) {
      var openQuery;
      openQuery = openQueries[queryId];
      if (callback == null) {
        callback = openQuery.initialCallback;
      }
      openQuery.once('success', function(result) {
        return callback(null, result, queryId);
      });
      return openQuery.next();
    };

    PrologDb.prototype.closeQuery = function(queryId, callback) {
      return openQueries[queryId].destroy().on('destroy', callback);
    };

    PrologDb.prototype.openQuery = function(queryString, nEntries, callback) {
      var peng;
      return peng = pengines({
        server: this.serverUrl,
        application: this.applicationName,
        format: "json",
        destroy: false,
        sourceText: this.sourceText,
        ask: queryString,
        chunk: nEntries,
        cookieJar: this.cookieJar
      }).on('error', function(obj) {
        return callback(new Error("Error in operation: " + obj.data));
      }).on('failure', function(obj) {
        return callback(new Error("Pengine object failed: " + (JSON.stringify(obj))));
      }).on('create', function(result) {
        openQueries[peng.id] = peng;
        return openQueries[peng.id].initialCallback = callback;
      }).once('success', function(result) {
        return callback(null, result, peng.id);
      });
    };

    PrologDb.cleanUp = function() {
      var id, peng, results;
      results = [];
      for (id in openQueries) {
        peng = openQueries[id];
        if (peng.died) {
          results.push(delete openQueries[id]);
        } else {
          results.push(peng.destroy());
        }
      }
      return results;
    };

    return PrologDb;

  })();

  prologdb = function(options) {
    var applicationName, authOptions, cleanUp, cookieJar, maxQueryLength, openQueries, serverUrl, sourceText;
    openQueries = {};
    authOptions = options.authOptions, applicationName = options.applicationName, serverUrl = options.serverUrl, maxQueryLength = options.maxQueryLength, sourceText = options.sourceText;
    if (maxQueryLength == null) {
      maxQueryLength = 1000;
    }
    if (applicationName == null) {
      applicationName = "swish";
    }
    if (sourceText == null) {
      sourceText = "";
    }
    cookieJar = null;
    prologdb.setMaxQueryLength = function(newLength) {
      return maxQueryLength = newLength;
    };
    prologdb.authenticate = function(callback) {
      if (authOptions != null) {
        return simpleAuth(authOptions, (function(_this) {
          return function() {
            var error, newCookieJar;
            error = arguments[0], newCookieJar = arguments[arguments.length - 1];
            cookieJar = newCookieJar;
            return callback(error);
          };
        })(this));
      } else {
        cookieJar = request.jar();
        return callback(null);
      }
    };
    prologdb.addPresetSourceText = function(sourceTextNew, callback) {
      return sourceText = sourceText != null ? sourceText + "\n" + sourceTextNew : sourceTextNew;
    };
    prologdb.query = function(queryString, callback) {
      var peng, pengineOptions, queryResult;
      pengineOptions = {
        server: serverUrl,
        application: applicationName,
        format: "json",
        destroy: true,
        sourceText: sourceText,
        ask: queryString,
        chunk: maxQueryLength,
        cookieJar: cookieJar
      };
      queryResult = null;
      return peng = pengines(pengineOptions).on('error', function(obj) {
        return callback(new Error("Error in operation: " + obj.data));
      }).on('failure', function(obj) {
        return callback(new Error("Pengine object failed: " + obj.data));
      }).on('destroy', function() {
        return callback(null, queryResult);
      }).on('success', function(result) {
        queryResult = result;
        return peng.destroy();
      });
    };
    prologdb.queryMore = function(queryId, callback) {
      var openQuery;
      openQuery = openQueries[queryId];
      if (callback == null) {
        callback = openQuery.initialCallback;
      }
      openQuery.once('success', function(result) {
        return callback(null, result, queryId);
      });
      return openQuery.next();
    };
    prologdb.closeQuery = function(queryId, callback) {
      return openQueries[queryId].destroy().on('destroy', callback);
    };
    prologdb.openQuery = (function(_this) {
      return function(queryString, nEntries, callback) {
        var peng;
        return peng = pengines({
          server: serverUrl,
          application: applicationName,
          format: "json",
          destroy: false,
          sourceText: sourceText,
          ask: queryString,
          chunk: nEntries,
          cookieJar: cookieJar
        }).on('error', function(obj) {
          return callback(new Error("Error in operation: " + obj.data));
        }).on('failure', function(obj) {
          return callback(new Error("Pengine object failed: " + (JSON.stringify(obj))));
        }).on('create', function(result) {
          openQueries[peng.id] = peng;
          return openQueries[peng.id].initialCallback = callback;
        }).once('success', function(result) {
          return callback(null, result, peng.id);
        });
      };
    })(this);
    cleanUp = function() {
      var id, peng, results;
      results = [];
      for (id in openQueries) {
        peng = openQueries[id];
        if (peng.died) {
          results.push(delete openQueries[id]);
        } else {
          results.push(peng.destroy());
        }
      }
      return results;
    };
    return prologdb;
  };


  /*
  staticDb = null
  
  
  
  staticExport = (opts) ->
      staticDb = new PrologDb(opts)
   */


  /*
  for funcName,func of PrologDb.prototype
      
      eachFunc = (fName) -> (
          staticExport[fName] =  ((args...) ->
              staticDb[fName](args...)))
      
      eachFunc(funcName)
   */

  module.exports = prologdb;

}).call(this);
